#include <sys/io.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <sys/select.h>
#include <time.h>
#include <signal.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <curses.h>
#include <string.h>
#include <libgen.h>

//   
#define MPG321	"/Data/_prog/bin/mpg321"	/* "/usr/bin/mpg321" */
#define AMIXER	"/Data/_prog/bin/amixer"	/* "/usr/bin/amixer" */

//     
#define MAXLIST	10240

//     
#define MAXINPUT 1024

//    
#define FN_LIST	"list.use"

//     
#define FN_NUM	"curtrack"

//   ,   FN_LIST
char *list[MAXLIST];

//      *list
int numlist = 0;

//  ,   mpg321
int to_player[2], from_player[2];

//   ttyS0 -    IR
int fdSerial;

//   ,   mpg321
char input[MAXINPUT];

//   ,   IR
unsigned char ir_input;

//   
int track = 0;

//   
char track_name[MAXPATHLEN];

//    
int letter = 33;

//   : 1 - , 2 - , 3 -  
int ind_repos = 0;

// 
#define MAXVOLUME	63
int volume = 53, rvol = 53, lvol = 53;

// 
#define PANCENTER	50
int pan	= PANCENTER;

//    
int ir_mode = 0;

// ,   ir_mode    0
time_t ir_mode_timeout = 0;

//      "Mode"
int ir_first_num = 0;

// PID 
pid_t player_pid;

// ,     ()
time_t sleep_time = 0;

// ,     ()
int sleep_leave = 0;

// ,        
time_t i16_changelock = 0;

// ,       
time_t i16_scrolllock = 0;

//    
#define INDLEN		16

//  
unsigned char i16_Buffer[INDLEN+1]; //    \0  snprintf

//   
time_t get_current_time() {
  return time(NULL);
}


//     
void i16_SendByte(unsigned char d) {
  int i;
  if (d == '\n') d = 255; else {
    if (d == '\0') d = ' ';
    if (d == (unsigned char)'') d = '';
    if (d == (unsigned char)'') d = '';
    if (d <= 127) d -= 32; else d -= 192 - 96;
  };
  write(fdSerial, &d, 1);
  for (i = 0; i < 5000; i++) ;
//  usleep(100);
}


//     
void i16_SendStr(unsigned char *s) {
  while (*s) i16_SendByte(*s++);
}


//     
void i16_SendBuf() {
  int i;

  i16_SendByte('\n');
  for (i = 0; i < INDLEN; i++) {
    i16_SendByte(i16_Buffer[i]);
  };
}


//      ,   (n >= 0) 
//  (n < 0)  
void i16_MoveToBuf(char *s, int n) {
  int i;
  char *p;

  if (n < 0) p = s; else p = s + n;
  for (i = 0; i < INDLEN; i++) {
    if (*p) {
      i16_Buffer[i] = *p++;
    } else {
      i16_Buffer[i] = ' ';
      if (n >= 0) p = s;
    }
  };
}


// /   
void readbase() {
  FILE *f;
  int i;
  char *p, *m;
  struct stat st;

  stat(FN_LIST, &st);
  p = (char *) malloc(st.st_size);
  f = fopen(FN_LIST, "r"); fread(p, st.st_size, 1, f); fclose(f);

  numlist = 0;
  list[0] = p;
  for (m = p; m < p+st.st_size; m++) {
    if (*m == 0x0a) {
      *m = 0;
      numlist++;
      list[numlist] = m+1;
    };
  };
  for (i = numlist+1; i < MAXLIST; i++) {
    list[i] = 0;
  };
}


//      
void loadtr(int *tr) {
  FILE *f;
  char name[MAXPATHLEN];
  int i;

  f = fopen(FN_NUM, "r"); fread(name, sizeof(name), 1, f); fclose(f);

  name[sizeof(name) - 1] = 0;
  for (i = 0; i < sizeof(name); i++) if (name[i] == '\n') name[i] = 0;

  for (i = 0; i < numlist; i++) {
    if (! strcmp(name, list[i])) {
      *tr = i;
      return;
    };     
  };
  *tr = 0;
}


//      
void savetr(int tr) {
  FILE *f;

  f = fopen(FN_NUM, "w"); fprintf(f, "%s\n", list[tr]); fclose(f);
}


//        
void ini_player() {
  pipe(to_player); // [0] -  , [1] -  
  pipe(from_player);
  if (player_pid = fork()) {
    //  
  } else {
    //  
    close(STDIN_FILENO);
    close(STDOUT_FILENO);
    dup2(to_player[0], STDIN_FILENO);
    dup2(from_player[1], STDOUT_FILENO);
    execl(MPG321, "", "-R", "abcd", 0);
    exit(0);
  };
}


//   
void put_line_to_player(char *s) {
  char cr[1]="\n";

  move(1, 1);
  printw(">> Send: %s\n", s);
  write(to_player[1], s, strlen(s));
  write(to_player[1], cr, sizeof(cr));  
}


//     
/*
void chg_volume(int dv) {
  static int volume = 53;

  volume += dv;
  if (volume > 63) volume = 63;
  if (volume < 0) volume = 0;
  set_volume(volume);
}
*/

//   / 
int is_present(int tr) {
  FILE *f;

  //    access -     ?
  if (f = fopen(list[tr], "r")) {
    fclose(f);
    return 1;
  } else {
    return 0;
  };
}


//    s  len  ,    \0
char *tag2str(char *s, int len) {
  static char p[MAXPATHLEN];
  char *m;

  strncpy(p, s, len);
  m = p + len - 1;
  while (m > p && *m == ' ') m--;
  m++;
  *m = 0;
  return p;
}


//    
void get_id3_tag(int n, unsigned char *tn) {
  struct {
    char tag[3];
    char track[30];
    char artist[30];
    char album[30];
    char year[4];
    char comment[30];
    unsigned char genre;
  } tagrec;
  int fd, t, rd;
  unsigned char *p;
  const unsigned char w2k[256] = {
       0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16,
      17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33,
      34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50,
      51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67,
      68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84,
      85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99,100,101,
     102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,
     119,120,121,122,123,124,125,126,127, 45, 45, 45, 45, 45, 95, 45, 45,
      45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 39, 96, 39, 45, 45, 45, 45,
      45, 45, 45, 45, 45, 45, 45, 45,159,151, 45,157, 45,148, 45,179, 45,
     153, 96,131, 45, 45,147,156, 45, 45, 45, 45, 45, 45, 45,163,191,152,
      39, 45, 45, 45,155,225,226,247,231,228,229,246,250,233,234,235,236,
     237,238,239,240,242,243,244,245,230,232,227,254,251,253,255,249,248,
     252,224,241,193,194,215,199,196,197,214,218,201,202,203,204,205,206,
     207,208,210,211,212,213,198,200,195,222,219,221,223,217,216,220,192,
     209};

  fd = open(list[n], O_RDONLY);

  lseek(fd, -sizeof(tagrec), SEEK_END);
  rd = read(fd, &tagrec, sizeof(tagrec));

  strcpy(tn, list[n] + 13);	//  "/Data/_music/"

  if ( rd != sizeof(tagrec) || tagrec.tag[0] != 'T' || tagrec.tag[1] != 'A' || tagrec.tag[2] != 'G') {
    t = strlen(tn);		//  ".mp3"  "    " -   
    tn[t-1] = ' ';
    tn[t-2] = ' ';
    tn[t-3] = ' ';
    tn[t-4] = ' ';
  } else {
    p = (unsigned char *)&tagrec;
    for (rd = 1; rd < sizeof(tagrec); rd++) {
      *p = w2k[*p];
      p++;
    };
    strcpy(tn, dirname(tn));
    strcat(tn, "/");
    strcat(tn, tag2str(tagrec.artist, sizeof(tagrec.artist)));
    strcat(tn, " - ");
    strcat(tn, tag2str(tagrec.track, sizeof(tagrec.track)));
    strcat(tn, "    ");
  };

  close(fd);
}


//  curses
void ini_curses() {
  initscr();
  noecho();
  cbreak();
  keypad(stdscr, TRUE);
  nodelay(stdscr, TRUE);
  clear();
};


//     IR  (   )   
int get_byte_from_IR(unsigned char *to) {
  fd_set r;
  struct timeval tv;

  tv.tv_sec = 0; tv.tv_usec = 0;
  FD_ZERO(&r); FD_SET(fdSerial, &r);
  if ( select(fdSerial+1, &r, NULL, NULL, &tv) > 0 ) {
    read(fdSerial, to, 1);
    return 1;
  };
  return 0;
};


//     IR
// ( -  3 ,  ,  -     )
int get_command_from_IR() {
  static unsigned char cnt = 0, d1, d2 = 255;

ret:
  if ( get_byte_from_IR(&d1) ) {
    if (d1 == d2) {
      if (cnt) {
        cnt--;
	goto ret;
      } else {
        d2 = 255;
	ir_input = d1;
        return 1;
	cnt = 1;
      };
    } else {
      d2 = d1;
      cnt = 1;
      goto ret;
    };
  };
  return 0;
};


//      mpg321,   ţ   0.1 
int get_line_from_player() {
  fd_set r;
  struct timeval tv;
  int f;
  static int i = 0;

  tv.tv_sec = 0; tv.tv_usec = 100000;
  FD_ZERO(&r); FD_SET(from_player[0], &r);
  if ( select(from_player[0]+1, &r, NULL, NULL, &tv) > 0 ) {

    do {
      f = read(from_player[0], &(input[i++]), 1);
    } while (f != 0 && input[i-1] != '\n');

    if (input[i-1] == '\n') {
      //    .       
      input[i-1] = 0;
      i = 0;
      return 1;
    };

  };
  return 0;
}


//      (     ))
int my_recase(int k) {
  unsigned char tsrc[] = "qwertyuiopasdfghjklzxcvbnm QWERTYUIOP{}ASDFGHJKL:\"ZXCVBNM<>?";
  unsigned char tdst[] = "QWERTYUIOPASDFGHJKLZXCVBNM ";
  int i;

  for (i = 0; i <= strlen(tsrc); i++) if (k == tsrc[i]) { k = tdst[i]; break; };
  return k;
}


//      
void go_letter(int *n, int letter) {
  int i;
  unsigned char c;

  ind_repos = 1;
  for (i = 0; i < numlist; i++) {
    c = *(list[i] + 13); //  "/Data/_music/"
//    printf("i=%d, key=%d, c=%d, list=%s\n", i, key, c, list[i]);
    if ( c >= letter ) { *n = i; return; };
  };
}


//    
void down(int exitcode) {
  put_line_to_player("quit");
  if (player_pid) kill(player_pid, SIGTERM);
  i16_MoveToBuf("Stop Player :))", -1); i16_SendBuf(); sleep(1);
  close(fdSerial);
  endwin();
  exit(exitcode);
}


//  
void set_volume() {
  char s[8];
  int status;

  lvol = rvol = volume;
  if (pan < PANCENTER) rvol -= PANCENTER - pan;
  if (pan > PANCENTER) lvol -= pan - PANCENTER;
  if (lvol < 0) lvol = 0;
  if (rvol < 0) rvol = 0;
  sprintf(s, "%d,%d", lvol, rvol);
  if (fork()) {
    //  
    wait(&status); //    
  } else {
    //  
    execl(AMIXER, "", "-q", "sset", "Master", s, 0);
    _exit(0); //   -  mixer  ,     
  };
}


//       
void test_track(int *track) {
  if (*track < 0) *track = numlist;
  if (*track > numlist) *track = 0;
}


//   (   track)
void set_track() {
  char load[5 + MAXPATHLEN]="load ";

  while (! is_present(track)) {
    track++;
    test_track(&track);
  };

//  if (is_present(track)) {
    savetr(track);

    strcpy(&(load[5]), list[track]);
    put_line_to_player(load);

    get_id3_tag(track, track_name);
    letter = (unsigned char) *(list[track] + 13);

    move(10, 0);
    printw(">> play: %s    \n", list[track]);
    printw(">> play: %s    \n", track_name);
//  } else {
//    move(10, 0);
//    printw(">> play: %s - fault  \n", list[track]);
//  };
}


//   
void set_sleep() {
  if (sleep_leave) {
    sleep_time = get_current_time() + (sleep_leave * 60);
  } else {
    sleep_time = 0;
  };
}


//  
void restart() {
  down(1);
}


//  
void halt() {
  down(0);
}


//    letter
void set_letter() {
  go_letter(&track, letter);
  test_track(&track);
  set_track();
}


//    () letter
void test_letter(int *l) {
  if ( (*l > 0x9F && *l < 0xDF) || *l == 0x60 ) *l = 0xE0; else
  if ( (*l > 0x60 && *l < 0xA0) || *l == 0xDF ) *l = 0x5F; else
  if ( *l < 0 ) *l = 0; else
  if ( *l > 255 ) *l = 255;
}


//    
struct {
  char	*name;		// ,   
  int	*val;		//  
  int	buf;		//   
  int	min, max;	//      ...
  void	(*test)(int *);	// ...     
  void	(*action)();	// ,    
} ir_table[] = {
 { "Normal mode",	&track /*any*/,	0, 0,	0, 	NULL,		NULL },
 { "Volume %d",		&volume, 	0, 0,	63,	NULL,		&set_volume },
 { "Letter \"%c\" [%d]",&letter,	0, 0,	255,	&test_letter,	&set_letter },
 { "Track %d",		&track,		0, 0,	0,	&test_track,	&set_track },
 { "Sleep %d",		&sleep_leave,	0, 0,	9999,	NULL,		&set_sleep },
 { "Pan %d",		&pan,		0, 0,	100,	NULL,		&set_volume },
 { "Restart",		&track,		0, 0,	0,	NULL,		&restart },
 { "Halt",		&track,		0, 0,	0,	NULL,		&halt }
#define IRM_ALL		7
};


//       
void ir_mode_view() {
  i16_MoveToBuf("", -1); //  
  snprintf(i16_Buffer, INDLEN+1, ir_table[ir_mode].name, ir_table[ir_mode].buf, ir_table[ir_mode].buf);
  i16_SendBuf();
  if (ir_mode) i16_changelock = get_current_time() + 15; else i16_changelock = get_current_time() + 3;
  ir_mode_timeout = get_current_time() + 60;
}


/*
   :
1	2	3		0	1	2
4	5	6		3	4	5
7	8	9		6	7	8
mode	0/10	> 10		17	12	13

>	||	s		50	57	56
	<<	>>			48/58	49/59	 /
*/


//        
void ir_mode_test() {
  if (ir_table[ir_mode].test) {
    ir_table[ir_mode].test(&ir_table[ir_mode].buf);
  } else {
    if (ir_table[ir_mode].buf > ir_table[ir_mode].max) ir_table[ir_mode].buf = ir_table[ir_mode].max;
    if (ir_table[ir_mode].buf < ir_table[ir_mode].min) ir_table[ir_mode].buf = ir_table[ir_mode].min;
  };
}


//    "0" .. "9", "Enter" (">10"),     
void ir_mode_action() {
  switch(ir_input) {
    case 0: case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8:
      if (ir_first_num) {
        ir_table[ir_mode].buf = ir_input + 1;
	ir_first_num = 0;
      } else {
        ir_table[ir_mode].buf = ir_table[ir_mode].buf * 10 + ir_input + 1;
      };
      break;
    case 12:
      if (ir_first_num) {
        ir_table[ir_mode].buf = 0;
	ir_first_num = 0;
      } else {
        ir_table[ir_mode].buf = ir_table[ir_mode].buf * 10;
      };
      break;

    case 48:
      ir_table[ir_mode].buf /= 10;
    case 49:
      ir_first_num = 0;
      break;

    case 50:
      ir_table[ir_mode].buf--;
      ir_first_num = 1;
      ir_mode_test();
      *ir_table[ir_mode].val = ir_table[ir_mode].buf;
      ir_mode_view();
      if (ir_table[ir_mode].action) ir_table[ir_mode].action();
      break;
    case 56:
      ir_table[ir_mode].buf++;
      ir_first_num = 1;
      ir_mode_test();
      *ir_table[ir_mode].val = ir_table[ir_mode].buf;
      ir_mode_view();
      if (ir_table[ir_mode].action) ir_table[ir_mode].action();
      break;

    case 13:
      *ir_table[ir_mode].val = ir_table[ir_mode].buf;
      if (ir_table[ir_mode].action) ir_table[ir_mode].action();
      ir_mode = 0;
      break;
  };
  ir_mode_test();
  ir_mode_view();  
}


//   # n   s,  
/*
char *search_word(char *s, int n) {
  char *b;

  //   
  while (n > 1 && *s) if (*s++ == ' ') n--;
  b = s;

  //   
  while (*s != ' ' && *s != '.' && *s != 0) s++;
  *s = 0;

  return b;
}
*/


//       dirname
void mydirname(int n, char *p) {
  char t1[MAXPATHLEN], *t2;

  strcpy(t1, list[n]);
  t2 = dirname(t1);
  strcpy(p, t2);
}


//         (,     '_')
void myauthorname(int n, char *p) {
  char t1[MAXPATHLEN], *t2, t3[MAXPATHLEN], *t4;

  strcpy(t1, list[n]);			// t1 = /Data/_music/ar/tr.mp3
  do {
    t2 = dirname(t1);			// t2 = /Data/_music/ar
    strcpy(p, t2);
      strcpy(t3, p);			// t3 = p = t2 = /Data/_music/ar
      t4 = basename(dirname(t3));	// t4 = _music
      if (t4[0] == '_') break;
    strcpy(t1, p);
  } while (strlen(t1) > 5);
}


//        
void nextdir(int d) {
  char cur[MAXPATHLEN], nex[MAXPATHLEN];
  int fr;

  fr = track; // 
  mydirname(track, cur);
  do {
    track += d;
    test_track(&track);
    mydirname(track, nex);
  } while (! strcmp(cur, nex) && fr != track);
}


//        
// (:   ,    '_')
void nextauthor(int d) {
  char cur[MAXPATHLEN], nex[MAXPATHLEN];
  int fr;

  fr = track; // 
  myauthorname(track, cur);
  do {
    track += d;
    test_track(&track);
    myauthorname(track, nex);
  } while (! strcmp(cur, nex) && fr != track);
}


//     
int track_pos() {
  char *p = track_name + strlen(track_name);
  while (p > track_name) {
    if (*p == '/') { return p - track_name + 1; };
    p--;
  };
  return 0;
}


//    ( )     
int dir_pos() {
  char *p = track_name + track_pos() - 2;
  while (p > track_name) {
    if (*p == '/') { return p - track_name + 1; };
    p--;
  };
  return 0;
}

//        
// (:   ,    '_')
int author_pos() {
  char *p = track_name + dir_pos();
  int r = p - track_name;

  p -= 2;
next:
  while (p > track_name) {
    if (*p == '/') {
      p++;
      if (*p == '_') { return r; } else {
        r = p - track_name;
	p -= 3;
	goto next;
      };
    };
    p--;
  };

  if (*p == '_') return r;
  return 0;
}


//       ,     
// (   )
void i_show_current(char *s, char *tn) {
  static int skip = 0;
  static int pos = 0;
  float ok, os;

  if (skip > 0) {
    skip--;
  } else {
    if (i16_changelock <= get_current_time()) {
      if (ind_repos) i16_scrolllock = get_current_time() + 2;
      switch (ind_repos) {
        case 1: pos = author_pos();	break;
	case 2: pos = dir_pos();	break;
	case 3: pos = track_pos();	break;
      };
      ind_repos = 0;
      sscanf(s, "@F %*d %*d %f %f", &ok, &os);
      i16_MoveToBuf(tn, pos);
      if (ok + os && i16_scrolllock <= get_current_time()) snprintf(&i16_Buffer[INDLEN-3], 4, " %2.0f", ok / (ok + os) * 100);
    };

    i16_SendBuf(); //    ,       ɣ   
    if (i16_scrolllock <= get_current_time()) {
      pos += 2;
      if (pos >= strlen(tn)) pos = 0;
    };
    skip = 12;
  };
}


main() {
  int key;

  if ((fdSerial = open("/dev/ttyS0", O_RDWR)) == -1) {
    perror("open serial");
    exit(0); //      
  };

  i16_MoveToBuf("Start Player :))", -1); i16_SendBuf();

  set_volume();
  ini_curses();
  readbase();
  ini_player();

  loadtr(&track);
  set_track();

  do {

    while ((key = getch()) == ERR && ! get_command_from_IR() ) {
//      usleep(5000);
      if (key == ERR) if (get_line_from_player() ) {
        if (! strcmp(input, "@P 0")) { track++; test_track(&track); set_track(); };
	if (input[1] = 'F') {
	  attron(A_REVERSE);
	  move(1, 1);
	  printw(">> pos: %s   \n", input);
  	  attroff(A_REVERSE);
	  i_show_current(input, track_name);
        } else {
	  attron(A_BOLD);
	  printw("%s \n", input);
	  attroff(A_BOLD);
	};
      };

      move(17, 1);
      if (sleep_time && ! ir_mode) {
        sleep_leave = (sleep_time - get_current_time()) / 60;
	attron(A_BLINK);
	printw("Sleep leave: %d minutes    ", sleep_leave);
	attroff(A_BLINK);	
        if (get_current_time() > sleep_time) down(0);
      } else {
        clrtoeol();
      };

      if (ir_mode_timeout && get_current_time() > ir_mode_timeout) {
        ir_mode = 0;
	ir_first_num = 1;
	ir_mode_view();
	ir_mode_timeout = 0;
      };
    };

    switch (key) {
      case KEY_RIGHT:	ind_repos = 3; track++;		test_track(&track); set_track(); break;
      case KEY_LEFT:	ind_repos = 3; track--;		test_track(&track); set_track(); break;
      case KEY_UP:	ind_repos = 2; nextdir( 1);	test_track(&track); set_track(); break;
      case KEY_DOWN:	ind_repos = 2; nextdir(-1);	test_track(&track); set_track(); break;
      case KEY_PPAGE:	ind_repos = 1; nextauthor( 1);	test_track(&track); set_track(); break;
      case KEY_NPAGE:	ind_repos = 1; nextauthor(-1);	test_track(&track); set_track(); break;
      case ' ':		put_line_to_player("pause"); break;
      case ',':		put_line_to_player("jump -100"); break;
      case '.':		put_line_to_player("jump +100"); break;
      case '0':
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      case '8':
      case '9':		sleep_leave = (key-'0') * 10; set_sleep(); break;
      case KEY_F(9):	break; //     go_letter
      case KEY_F(10):	break;
      case ERR:		switch(ir_input) {
    			  //  ,   ir_mode
			  case 17: if (ir_mode >= IRM_ALL) ir_mode = 0; else ir_mode++; ir_table[ir_mode].buf = *ir_table[ir_mode].val; ir_first_num = 1; ir_mode_view(); break;
			  case 57: put_line_to_player("pause"); break;
			  default:
			    if (ir_mode) {
			      //      normal
			      ir_mode_action();
			    } else {
			      //     normal
			      switch(ir_input) {
			        case 0: ind_repos = 1; nextauthor(-1);	test_track(&track); set_track(); break;
				case 1: ind_repos = 1; break;
				case 2: ind_repos = 1; nextauthor( 1);	test_track(&track); set_track(); break;
				case 3: ind_repos = 2; nextdir(-1);	test_track(&track); set_track(); break;
				case 4: ind_repos = 2; break;
				case 5: ind_repos = 2; nextdir( 1);	test_track(&track); set_track(); break;
				case 6: ind_repos = 3; track--;		test_track(&track); set_track(); break;
				case 7: ind_repos = 3; break;
				case 8: ind_repos = 3; track++;		test_track(&track); set_track(); break;
    			        case 50: put_line_to_player("jump -100"); break;
			        case 56: put_line_to_player("jump +100"); break;
			      };
			    };
			};
    			break; //    IR
      default:		go_letter(&track, my_recase(key)); test_track(&track); set_track();
    };

/*
   :
1	2	3		0	1	2
4	5	6		3	4	5
7	8	9		6	7	8
mode	0/10	> 10		17	12	13

>	||	s		50	57	56
	<<	>>			48/58	49/59	 /
*/

  } while (key != KEY_F(10) && key != KEY_F(9));
  down(key == KEY_F(9) ? 1 : 0);
}
